diff --git a/src/main/java/net/minecraft/core/item/block/LeavesLayerBlockItem.java b/src/main/java/net/minecraft/core/item/block/LeavesLayerBlockItem.java
index 86303dcf7..0a6e9342a 100644
--- a/src/main/java/net/minecraft/core/item/block/LeavesLayerBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/LeavesLayerBlockItem.java
@@ -126,9 +126,9 @@ public class LeavesLayerBlockItem extends BlockItem
 			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, placeMeta))
 			{
 				if (player == null) {
-					Block.blocksList[blockID].onBlockPlacedByWorld(world, blockX, blockY, blockZ);
+					Block.blocksList[blockID].onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 				} else {
-					Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
+					Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
 				}
 				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 				itemstack.consumeItem(player);
diff --git a/src/main/java/net/minecraft/core/item/block/SlabBlockItem.java b/src/main/java/net/minecraft/core/item/block/SlabBlockItem.java
index 27291fc9b..057849ee2 100644
--- a/src/main/java/net/minecraft/core/item/block/SlabBlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/SlabBlockItem.java
@@ -91,9 +91,9 @@ public class SlabBlockItem extends BlockItem
             if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, placeMeta))
             {
                 if (player == null) {
-                    Block.blocksList[blockID].onBlockPlacedByWorld(world, blockX, blockY, blockZ);
+                    Block.blocksList[blockID].onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
                 } else {
-                    Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
+                    Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
                 }
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
                 itemstack.consumeItem(player);
diff --git a/src/main/java/net/minecraft/core/net/IUpdatePlayerListBox.java b/src/main/java/net/minecraft/core/net/IUpdatePlayerListBox.java
index a60921f36..1afcbd866 100644
--- a/src/main/java/net/minecraft/core/net/IUpdatePlayerListBox.java
+++ b/src/main/java/net/minecraft/core/net/IUpdatePlayerListBox.java
@@ -4,5 +4,5 @@ package net.minecraft.core.net;
 public interface IUpdatePlayerListBox
 {
 
-    public abstract void update();
+    void update();
 }
diff --git a/src/main/java/net/minecraft/core/net/NetworkManager.java b/src/main/java/net/minecraft/core/net/NetworkManager.java
index 684d1fa97..56421ff3d 100644
--- a/src/main/java/net/minecraft/core/net/NetworkManager.java
+++ b/src/main/java/net/minecraft/core/net/NetworkManager.java
@@ -314,7 +314,8 @@ public class NetworkManager
         for(int i = 100; !incoming.isEmpty() && i >= 0; i--)
         {
             Packet packet = incoming.remove(0);
-            packet.handlePacket(packetListener);
+            if (!disconnected)
+                packet.handlePacket(packetListener);
         }
 
         wakeThreads();
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/BlockArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/BlockArgumentType.java
index 6d2518474..0c8aadfab 100644
--- a/src/main/java/net/minecraft/core/net/command/arguments/BlockArgumentType.java
+++ b/src/main/java/net/minecraft/core/net/command/arguments/BlockArgumentType.java
@@ -18,7 +18,7 @@ import java.util.Locale;
 import java.util.concurrent.CompletableFuture;
 
 public class BlockArgumentType implements ArgumentType<BlockInput> {
-    private static final List<String> EXAMPLES = Arrays.asList("tile.stone", "stone", "tile.log[1]");
+    private static final List<String> EXAMPLES = Arrays.asList("minecraft:block/stone", "block/stone", "minecraft:block/log_oak[1]");
 
     public static ArgumentType<BlockInput> block() {
         return new BlockArgumentType();
@@ -42,9 +42,9 @@ public class BlockArgumentType implements ArgumentType<BlockInput> {
             String remaining = suggestionsBuilder.getRemaining().toLowerCase(Locale.ROOT);
             for (Block block : Block.blocksList) {
                 if (block == null) continue;
-                CommandHelper.getStringToSuggest(block.getKey(), remaining).ifPresent(suggestionsBuilder::suggest);
-                CommandHelper.getStringToSuggest("tile.air", remaining).ifPresent(suggestionsBuilder::suggest);
+                CommandHelper.getStringToSuggest(block.namespaceID.toString(), remaining).ifPresent(suggestionsBuilder::suggest);
             }
+            CommandHelper.getStringToSuggest(BlockArgumentParser.AIR_BLOCK.toString(), remaining).ifPresent(suggestionsBuilder::suggest);
             suggestionsBuilder.buildFuture();
         });
     }
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/SeasonArgumentType.java b/src/main/java/net/minecraft/core/net/command/arguments/SeasonArgumentType.java
new file mode 100644
index 000000000..8d9867b18
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/arguments/SeasonArgumentType.java
@@ -0,0 +1,62 @@
+package net.minecraft.core.net.command.arguments;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.arguments.ArgumentType;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.world.season.Season;
+import net.minecraft.core.world.season.SeasonManager;
+import net.minecraft.core.world.season.SeasonManagerCycle;
+import net.minecraft.core.world.season.Seasons;
+
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.List;
+import java.util.concurrent.CompletableFuture;
+
+public class SeasonArgumentType implements ArgumentType<String> {
+    private static final List<String> EXAMPLES = Arrays.asList("overworld.winter", "overworld.summer", "paradise.gold");
+
+    public static ArgumentType<String> season() {
+        return new SeasonArgumentType();
+    }
+
+    @Override
+    public String parse(StringReader reader) throws CommandSyntaxException {
+        final String string = reader.readString();
+
+        for (Season s : Seasons.getAllSeasons()) {
+            if (s.getId().equalsIgnoreCase(string)) {
+                return s.getId();
+            }
+        }
+        throw new CommandSyntaxException(CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument(), () -> I18n.getInstance().translateKeyAndFormat("command.argument_types.season.invalid_id", string));
+    }
+
+    @Override
+    public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
+        if (context.getSource() instanceof CommandSource) {
+            CommandSource commandSource = (CommandSource) context.getSource();
+            SeasonManager seasonManager = commandSource.getWorld().getSeasonManager();
+            if (seasonManager instanceof SeasonManagerCycle) {
+                for (Season s : seasonManager.getSeasons()) {
+                    builder.suggest(s.getId());
+                }
+            }
+        } else {
+            for (Season s : Seasons.getAllSeasons()) {
+                builder.suggest(s.getId());
+            }
+        }
+        return builder.buildFuture();
+    }
+
+    @Override
+    public Collection<String> getExamples() {
+        return EXAMPLES;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/FillCommand.java b/src/main/java/net/minecraft/core/net/command/commands/FillCommand.java
index 30490476a..20805ea11 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/FillCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/FillCommand.java
@@ -31,7 +31,7 @@ public class FillCommand {
                             if (CommandHelper.getVolume(c.getSource(), first, second) > 32768)
                                 throw CommandExceptions.volumeTooLarge().create();
                             int blocksFilled = fillReplace(c.getSource(), c.getSource().getWorld(), first, second, block);
-                            c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "commands.fill.success_multiple", blocksFilled);
+                            c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "command.commands.fill.success_multiple", blocksFilled);
                             return blocksFilled;
                         })
                         .then(LiteralArgumentBuilder.<CommandSource>literal("replace")
@@ -42,7 +42,7 @@ public class FillCommand {
                                 if (CommandHelper.getVolume(c.getSource(), first, second) > 32768)
                                     throw CommandExceptions.volumeTooLarge().create();
                                 int blocksFilled = fillReplace(c.getSource(), c.getSource().getWorld(), first, second, block);
-                                c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "commands.fill.success_multiple", blocksFilled);
+                                c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "command.commands.fill.success_multiple", blocksFilled);
                                 return blocksFilled;
                             })
                             .then(RequiredArgumentBuilder.<CommandSource, BlockInput>argument("filter", BlockArgumentType.block())
@@ -54,7 +54,7 @@ public class FillCommand {
                                     if (CommandHelper.getVolume(c.getSource(), first, second) > 32768)
                                         throw CommandExceptions.volumeTooLarge().create();
                                     int blocksFilled = fillReplace(c.getSource(), c.getSource().getWorld(), first, second, block, filter);
-                                    c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "commands.fill.success_multiple", blocksFilled);
+                                    c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "command.commands.fill.success_multiple", blocksFilled);
                                     return blocksFilled;
                                 })))
                         .then(LiteralArgumentBuilder.<CommandSource>literal("hollow")
@@ -65,7 +65,7 @@ public class FillCommand {
                                 if (CommandHelper.getVolume(c.getSource(), first, second) > 32768)
                                     throw CommandExceptions.volumeTooLarge().create();
                                 int blocksFilled = fillHollow(c.getSource(), c.getSource().getWorld(), first, second, block);
-                                c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "commands.fill.success_multiple", blocksFilled);
+                                c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "command.commands.fill.success_multiple", blocksFilled);
                                 return blocksFilled;
                             }))
                         .then(LiteralArgumentBuilder.<CommandSource>literal("outline")
@@ -76,7 +76,7 @@ public class FillCommand {
                                 if (CommandHelper.getVolume(c.getSource(), first, second) > 32768)
                                     throw CommandExceptions.volumeTooLarge().create();
                                 int blocksFilled = fillOutline(c.getSource(), c.getSource().getWorld(), first, second, block);
-                                c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "commands.fill.success_multiple", blocksFilled);
+                                c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "command.commands.fill.success_multiple", blocksFilled);
                                 return blocksFilled;
                             }))
                         .then(LiteralArgumentBuilder.<CommandSource>literal("keep")
@@ -87,7 +87,7 @@ public class FillCommand {
                                 if (CommandHelper.getVolume(c.getSource(), first, second) > 32768)
                                     throw CommandExceptions.volumeTooLarge().create();
                                 int blocksFilled = fillKeep(c.getSource(), c.getSource().getWorld(), first, second, block);
-                                c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "commands.fill.success_multiple", blocksFilled);
+                                c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "command.commands.fill.success_multiple", blocksFilled);
                                 return blocksFilled;
                             }))
                         .then(LiteralArgumentBuilder.<CommandSource>literal("destroy")
@@ -98,7 +98,7 @@ public class FillCommand {
                                 if (CommandHelper.getVolume(c.getSource(), first, second) > 32768)
                                     throw CommandExceptions.volumeTooLarge().create();
                                 int blocksFilled = fillDestroy(c.getSource(), c.getSource().getWorld(), first, second, block);
-                                c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "commands.fill.success_multiple", blocksFilled);
+                                c.getSource().sendTranslatableMessage(blocksFilled == 1 ? "command.commands.fill.success_single" : "command.commands.fill.success_multiple", blocksFilled);
                                 return blocksFilled;
                             }))))));
     }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/MobSpawningCommand.java b/src/main/java/net/minecraft/core/net/command/commands/MobSpawningCommand.java
index 462d35345..9734b8079 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/MobSpawningCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/MobSpawningCommand.java
@@ -13,6 +13,7 @@ import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.EntitySummonArgumentType;
 import net.minecraft.core.world.SpawnerMobs;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.config.spawning.SpawnerConfig;
 
 import java.util.Collection;
 
@@ -28,7 +29,7 @@ public class MobSpawningCommand {
                     .then(LiteralArgumentBuilder.<CommandSource>literal("list").executes(c -> {
                         Collection<String> ids = EntityDispatcher.classToKeyMap.values();
                         World world = c.getSource().getWorld();
-                        SpawnerMobs.SpawnerConfig config = world.spawningConfig;
+                        SpawnerConfig config = world.getSpawnerConfig();
                         for (String s : ids) {
                             c.getSource().sendMessage(String.format("%s : %s", s, config.canMobSpawn(s)));
                         }
@@ -42,7 +43,7 @@ public class MobSpawningCommand {
                             .then(RequiredArgumentBuilder.<CommandSource, Boolean>argument("value", BoolArgumentType.bool())
                                 .executes(c -> {
                                     World world = c.getSource().getWorld();
-                                    SpawnerMobs.SpawnerConfig config = world.spawningConfig;
+                                    SpawnerConfig config = world.getSpawnerConfig();
 
                                     String mobId = EntityDispatcher.getEncodeId(c.getArgument("entity", Class.class));
                                     boolean value = c.getArgument("value", Boolean.class);
@@ -54,7 +55,7 @@ public class MobSpawningCommand {
                         .then(RequiredArgumentBuilder.<CommandSource, Boolean>argument("value", BoolArgumentType.bool())
                             .executes(c -> {
                                 World world = c.getSource().getWorld();
-                                SpawnerMobs.SpawnerConfig config = world.spawningConfig;
+                                SpawnerConfig config = world.getSpawnerConfig();
 
                                 boolean value = c.getArgument("value", Boolean.class);
                                 config.setPassiveSpawning(value);
@@ -65,7 +66,7 @@ public class MobSpawningCommand {
                         .then(RequiredArgumentBuilder.<CommandSource, Boolean>argument("value", BoolArgumentType.bool())
                             .executes(c -> {
                                 World world = c.getSource().getWorld();
-                                SpawnerMobs.SpawnerConfig config = world.spawningConfig;
+                                SpawnerConfig config = world.getSpawnerConfig();
 
                                 boolean value = c.getArgument("value", Boolean.class);
                                 config.setHostileSpawning(value);
diff --git a/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java b/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java
index 4a02e4725..eb1613ce8 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java
@@ -2,83 +2,134 @@ package net.minecraft.core.net.command.commands;
 
 import com.mojang.brigadier.Command;
 import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.arguments.IntegerArgumentType;
 import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import net.minecraft.core.Global;
+import net.minecraft.core.net.command.arguments.SeasonArgumentType;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.TimeArgumentType;
+import net.minecraft.core.world.season.Season;
+import net.minecraft.core.world.season.SeasonManager;
+import net.minecraft.core.world.season.SeasonManagerCycle;
+import net.minecraft.core.world.season.Seasons;
 
 public class TimeCommand {
     public static void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("time")
-                .requires(CommandSource::hasAdmin)
-                .then(LiteralArgumentBuilder.<CommandSource>literal("query")
-                        .then(LiteralArgumentBuilder.<CommandSource>literal("daytime")
-                                .executes(c -> {
-                                    CommandSource source = c.getSource();
-                                    source.sendTranslatableMessage("command.commands.time.query", c.getSource().getWorld().getWorldTime() % 24000L);
-
-                                    return Command.SINGLE_SUCCESS;
-                                }))
-                        .then(LiteralArgumentBuilder.<CommandSource>literal("gametime")
-                                .executes(c -> {
-                                    CommandSource source = c.getSource();
-                                    source.sendTranslatableMessage("command.commands.time.query", source.getWorld().getWorldTime() % Integer.MAX_VALUE);
-
-                                    return Command.SINGLE_SUCCESS;
-                                }))
-                        .then(LiteralArgumentBuilder.<CommandSource>literal("day")
-                                .executes(c -> {
-                                    CommandSource source = c.getSource();
-                                    source.sendTranslatableMessage("command.commands.time.query", source.getWorld().getWorldTime() / 24000L % Integer.MAX_VALUE);
-
-                                    return Command.SINGLE_SUCCESS;
-                                })))
-                .then(LiteralArgumentBuilder.<CommandSource>literal("set")
-                        .then(RequiredArgumentBuilder.<CommandSource, Integer>argument("time", TimeArgumentType.time())
-                                .executes(c -> {
-                                    CommandSource source = c.getSource();
-                                    int time = c.getArgument("time", Integer.class);
-                                    setWorldTime(source, source.getWorld(), time);
-                                    return Command.SINGLE_SUCCESS;
-                                }))
-                        .then(LiteralArgumentBuilder.<CommandSource>literal("day")
-                                .executes(c -> {
-                                    CommandSource source = c.getSource();
-                                    setDayTime(source, source.getWorld(), 1000);
-                                    return Command.SINGLE_SUCCESS;
-                                }))
-                        .then(LiteralArgumentBuilder.<CommandSource>literal("noon")
-                                .executes(c -> {
-                                    CommandSource source = c.getSource();
-                                    setDayTime(source, source.getWorld(), 6000);
-                                    return Command.SINGLE_SUCCESS;
-                                }))
-                        .then(LiteralArgumentBuilder.<CommandSource>literal("night")
-                                .executes(c -> {
-                                    CommandSource source = c.getSource();
-                                    setDayTime(source, source.getWorld(), 13000);
-                                    return Command.SINGLE_SUCCESS;
-                                }))
-                        .then(LiteralArgumentBuilder.<CommandSource>literal("midnight")
-                                .executes(c -> {
-                                    CommandSource source = c.getSource();
-                                    setDayTime(source, source.getWorld(), 18000);
-                                    return Command.SINGLE_SUCCESS;
-                                })))
-                .then(LiteralArgumentBuilder.<CommandSource>literal("add")
-                        .then(RequiredArgumentBuilder.<CommandSource, Integer>argument("time", TimeArgumentType.time())
-                                .executes(c -> {
-                                    CommandSource source = c.getSource();
-                                    int time = c.getArgument("time", Integer.class);
-                                    addWorldTime(source, source.getWorld(), time);
-                                    return Command.SINGLE_SUCCESS;
-                                }))));
+            .requires(CommandSource::hasAdmin)
+            .then(LiteralArgumentBuilder.<CommandSource>literal("query")
+                .then(LiteralArgumentBuilder.<CommandSource>literal("daytime")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        source.sendTranslatableMessage("command.commands.time.query", c.getSource().getWorld().getWorldTime() % 24000L);
+
+                        return Command.SINGLE_SUCCESS;
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("gametime")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        source.sendTranslatableMessage("command.commands.time.query", source.getWorld().getWorldTime() % Integer.MAX_VALUE);
+
+                        return Command.SINGLE_SUCCESS;
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("day")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        source.sendTranslatableMessage("command.commands.time.query", source.getWorld().getWorldTime() / 24000L % Integer.MAX_VALUE);
+
+                        return Command.SINGLE_SUCCESS;
+                        })))
+            .then(LiteralArgumentBuilder.<CommandSource>literal("set")
+                .then(RequiredArgumentBuilder.<CommandSource, Integer>argument("time", TimeArgumentType.time())
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        int time = c.getArgument("time", Integer.class);
+                        setWorldTime(source, source.getWorld(), time);
+                        return Command.SINGLE_SUCCESS;
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("day")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        setDayTime(source, source.getWorld(), 1000);
+                        return Command.SINGLE_SUCCESS;
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("noon")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        setDayTime(source, source.getWorld(), 6000);
+                        return Command.SINGLE_SUCCESS;
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("night")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        setDayTime(source, source.getWorld(), 13000);
+                        return Command.SINGLE_SUCCESS;
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("midnight")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        setDayTime(source, source.getWorld(), 18000);
+                        return Command.SINGLE_SUCCESS;
+                    }))
+                .then(RequiredArgumentBuilder.<CommandSource, String>argument("season", SeasonArgumentType.season())
+                    .requires(c -> c.getWorld().getSeasonManager() instanceof SeasonManagerCycle)
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+
+                        String seasonId = c.getArgument("season", String.class);
+                        Season targetSeason = Seasons.getSeason(seasonId);
+
+                        SeasonManagerCycle seasonManager = (SeasonManagerCycle) source.getWorld().getSeasonManager();
+
+                        int time = 0;
+                        for (Season season : seasonManager.getSeasons()) {
+                            if (season == targetSeason) break;
+                            time += seasonManager.getSeasonLengthTicks(season);
+                        }
+
+                        setWorldTime(source, source.getWorld(), source.getWorld().getWorldTime() - (source.getWorld().getWorldTime() % seasonManager.getYearLengthTicks()) + time);
+                        return Command.SINGLE_SUCCESS;
+                    })
+                    .then(RequiredArgumentBuilder.<CommandSource, Integer>argument("day", IntegerArgumentType.integer())
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+
+                            String seasonId = c.getArgument("season", String.class);
+                            Season targetSeason = Seasons.getSeason(seasonId);
+
+                            int day = c.getArgument("day", Integer.class);
+
+                            SeasonManagerCycle seasonManager = (SeasonManagerCycle) source.getWorld().getSeasonManager();
+
+                            int time = 0;
+                            for (Season season : seasonManager.getSeasons()) {
+                                if (season == targetSeason) break;
+                                time += seasonManager.getSeasonLengthTicks(season);
+                            }
+
+                            time += day * Global.DAY_LENGTH_TICKS;
+
+                            setWorldTime(source, source.getWorld(), source.getWorld().getWorldTime() - (source.getWorld().getWorldTime() % seasonManager.getYearLengthTicks()) + time);
+                            return Command.SINGLE_SUCCESS;
+                        })
+                    )
+                )
+            )
+            .then(LiteralArgumentBuilder.<CommandSource>literal("add")
+                .then(RequiredArgumentBuilder.<CommandSource, Integer>argument("time", TimeArgumentType.time())
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        int time = c.getArgument("time", Integer.class);
+                        addWorldTime(source, source.getWorld(), time);
+                        return Command.SINGLE_SUCCESS;
+                    }))));
     }
 
     private static void setDayTime(CommandSource source, World world, long time) {
-        setWorldTime(source, world, world.getWorldTime() - (world.getWorldTime() % 24000L) + time);
+        setWorldTime(source, world, world.getWorldTime() - (world.getWorldTime() % Global.DAY_LENGTH_TICKS) + time);
     }
 
     private static void setWorldTime(CommandSource source, World world, long time) {
